
/**
 * Klasse zur Beschreibung der Wasserkocheranzeige.
 * 
 * @author Klaus Reinold
 * @version 1.0
 */
class Wasserkocheranzeige extends Ereignisbehandlung
{
    // Attribute
    private Text einheit;
    private Text aktuell;
    private Text ziel;

    private double aktTemp, zielTemp;
    private String einheitText;

    private boolean istEingeschaltet;

    private static final Wasserkocheranzeige wka = new Wasserkocheranzeige();
    
    /**
     * Initialisiert die Attribute und die benötigten Formen
     */
    private Wasserkocheranzeige()
    {
        Dreieck d;
        d = new Dreieck();
        d.FarbeSetzen("grau");
        d.PositionSetzen(450, 175);
        d.GrößeSetzen(400, 150);
        d.Drehen(180);

        d = new Dreieck();
        d.FarbeSetzen("weiss");
        d.PositionSetzen(425, 200);
        d.GrößeSetzen(330, 100);
        d.Drehen(180);

        d = new Dreieck();
        d.FarbeSetzen("grau");
        d.PositionSetzen(200, 125);
        d.GrößeSetzen(200, 50);
        d.Drehen(180);

        d = new Dreieck();
        d.FarbeSetzen("gelb");
        d.PositionSetzen(350, 75);
        d.GrößeSetzen(300, 50);

        d = new Dreieck();
        d.FarbeSetzen("grau");
        d.PositionSetzen(200, 125);
        d.GrößeSetzen(100, 425);

        d = new Dreieck();
        d.FarbeSetzen("grau");
        d.PositionSetzen(500, 125);
        d.GrößeSetzen(100, 425);

        Rechteck r;
        r = new Rechteck();
        r.PositionSetzen(200, 125);
        r.FarbeSetzen("grau");
        r.GrößeSetzen(300, 425);

        r = new Rechteck();
        r.PositionSetzen(225, 400);
        r.FarbeSetzen("blau");
        r.GrößeSetzen(225, 100);

        einheitText = "°C";
        einheit = new Text();
        einheit.FarbeSetzen("weiß");
        einheit.PositionSetzen(250, 425);
        einheit.TextSetzen("Einheit: "+einheitText);

        aktTemp = 23;
        aktuell = new Text();
        aktuell.FarbeSetzen("weiß");
        aktuell.PositionSetzen(250, 450);
        aktuell.TextSetzen("aktuell: "+aktTemp);

        zielTemp = 100;
        ziel = new Text();
        ziel.FarbeSetzen("weiß");
        ziel.PositionSetzen(250, 475);
        ziel.TextSetzen("Ziel: "+zielTemp);

        super.TaktdauerSetzen(500);
        super.Starten();
        istEingeschaltet = false;
    }

    // weitere Methoden
    @Override void TaktImpulsAusführen()
    {
        if(istEingeschaltet)
        {
            if(aktTemp < zielTemp)
            {
                aktTemp = aktTemp + 1.0;
                aktuell.TextSetzen("aktuell: "+(int)aktTemp);
            }
            else
            {
                istEingeschaltet = false;
            }
        }
        else
        {
            if((aktTemp > 23 && einheitText=="°C") || (aktTemp > 73.4 && einheitText=="F"))
            {
                aktTemp = aktTemp - 0.1;
                aktuell.TextSetzen("aktuell: "+(int)aktTemp);
            }
        }
    }      

    void Anschalten()
    {
        istEingeschaltet = true;
    }

    void AnzeigeSetzen(String einh, double akt, double zielT)
    {
        aktTemp = akt;
        aktuell.TextSetzen("aktuell: "+(int)aktTemp);
        einheitText = einh; 
        einheit.TextSetzen("Einheit: "+einheitText);
        zielTemp = zielT;
        ziel.TextSetzen("Ziel: "+(int)zielTemp);
    }

    static Wasserkocheranzeige Geben()
    {
        return wka;
    }
}

