 
import java.util.*;
/**
 * Die Beute wandert zufällig über das Spielfeld.
 * Sie wechselt ihre Richtung immer wahrscheinlicher,
 * je länger sie gerade aus läuft.
 * Als Darstellungssymbol hat sie einen Kreis
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
class Beute extends Figur
{
    /** Zähler für die Bewegungsschritte geradeaus. */
    int zähler;
    /** Der Zufallsgenerator. */
    Random zufall;
    /** Breite des Spielfeldes. */
    int breite;
    /** Höhe des Spielfeldes. */
    int höhe;
    
    /**
     * Legt das Anzeigesymbol an und wählt eine zufällige Startposition.
     * @param breite Breite des Spielfelds
     * @param höhe Höhe des Spielfelds
     */
    Beute (int breite, int höhe)
    {
        zufall = new Random();
        this.breite = breite;
        this.höhe = höhe;
        PositionSetzen(zufall.nextInt(breite), zufall.nextInt(höhe));
        WinkelSetzen(zufall.nextInt(360));
        // Eigenes Aussehen der Beute einbauen
        
    }
    
    /**
     * Bewegt die Beute um 10 Einheiten in der eingestellten Richtung.
     * Wir der Rand erreicht, wird die Richtung nach dem Reflexionsgesetzt
     * gedreht. Außerdem wird sie spätestens nach 100 Schritten 
     * zufällig neu bestimmt; je länger die Geradesausbewegung,
     * desto wahrscheinlicher ist die zufällige Änderung.
     */
    @Override void AktionAusführen()
    {
        if (zufall.nextInt(100) < zähler)
        {
            WinkelSetzen(zufall.nextInt(360));
            zähler = 0;
        }
        Gehen (10);
        zähler = zähler + 1;
        if ((XPositionGeben() > breite) && (0 <= WinkelGeben()) && (WinkelGeben() < 90))
        {
            WinkelSetzen(180 - WinkelGeben());
        }
        else if ((XPositionGeben() > breite) && (270 < WinkelGeben()) && (WinkelGeben() < 360))
        {
            WinkelSetzen(540 - WinkelGeben());
        }
        else if  ((XPositionGeben() < 0) && (90 < WinkelGeben()) && (WinkelGeben() <=180))
        {
            WinkelSetzen(180 - WinkelGeben());
        }
        else if  ((XPositionGeben() < 0) && (180 < WinkelGeben()) && (WinkelGeben() < 270))
        {
            WinkelSetzen(540 - WinkelGeben());
        }
        if ((YPositionGeben() < 0) && ((0 < WinkelGeben()) || (WinkelGeben() < 180)))
        {
            WinkelSetzen(360 - WinkelGeben());
        }
        else if ((YPositionGeben() > höhe) && (180 < WinkelGeben()) && (WinkelGeben() < 360))
        {
            WinkelSetzen(360 - WinkelGeben());
        }
        if (Berührt())
        {
            Umfärben();
        }
    }

    /**
     * Färbt die erreichte Beute um.
     */
    void Umfärben()
    {
        // Eigene Form der Beute nach der Berührung einbauen.
        
    }
}
